From 271702c46fa6a48b44d00a2b89b27ae6b00c59b8 Mon Sep 17 00:00:00 2001
From: Matthew Harmsen <mharmsen@redhat.com>
Date: Fri, 4 May 2012 20:29:35 -0700
Subject: [PATCH] PKI Deployment Scriptlets

* Re-aligned code to account for revised layout documented at
  http://pki.fedoraproject.org/wiki/PKI_Instance_Deployment
* Massaged logic to comply with PKI subsystem running within
  a shared instance
* Developed code to take advantage of a single shared NSS security
  database model
* Completed the following two 'scriptlets':
  * Dogtag 10: Python 'slot_assignment.py' Installation Scriptlet
    (https://fedorahosted.org/pki/ticket/146)
  * Dogtag 10: Python 'security_databases.py' Installation Scriptlet
    (https://fedorahosted.org/pki/ticket/136)
* Created several additional PKI deployment helper utilities.
---
 base/ca/shared/conf/CS.cfg.in                    |    2 +-
 base/ca/shared/conf/tomcat.conf                  |   52 ++
 base/deploy/CMakeLists.txt                       |   27 +-
 base/deploy/config/pkideployment.cfg             |   11 +-
 base/deploy/config/pkislots.cfg                  |   88 +++
 base/deploy/src/pkidestroy                       |   25 +-
 base/deploy/src/pkispawn                         |   32 +-
 base/deploy/src/scriptlets/finalization.py       |    2 +
 base/deploy/src/scriptlets/initialization.py     |    9 +
 base/deploy/src/scriptlets/instance_layout.py    |   72 ++-
 base/deploy/src/scriptlets/pkiconfig.py          |   10 +-
 base/deploy/src/scriptlets/pkihelper.py          |  711 ++++++++++++++++++--
 base/deploy/src/scriptlets/pkimanifest.py        |    6 +
 base/deploy/src/scriptlets/pkimessages.py        |   47 ++-
 base/deploy/src/scriptlets/pkiparser.py          |  777 ++++++++++++++++++----
 base/deploy/src/scriptlets/security_databases.py |   89 +++-
 base/deploy/src/scriptlets/slot_assignment.py    |   52 --
 base/deploy/src/scriptlets/slot_substitution.py  |  120 ++++
 base/deploy/src/scriptlets/subsystem_layout.py   |   72 ++-
 base/deploy/src/scriptlets/war_explosion.py      |   22 +-
 base/deploy/src/scriptlets/webserver_layout.py   |  169 +++--
 base/kra/shared/conf/tomcat.conf                 |   52 ++
 base/ocsp/shared/conf/tomcat.conf                |   52 ++
 base/ra/apache/conf/httpd.conf                   |    2 +-
 base/tks/shared/conf/tomcat.conf                 |   52 ++
 base/tps/apache/conf/httpd.conf                  |    2 +-
 26 files changed, 2159 insertions(+), 396 deletions(-)
 create mode 100644 base/ca/shared/conf/tomcat.conf
 create mode 100644 base/deploy/config/pkislots.cfg
 delete mode 100644 base/deploy/src/scriptlets/slot_assignment.py
 create mode 100644 base/deploy/src/scriptlets/slot_substitution.py
 create mode 100644 base/kra/shared/conf/tomcat.conf
 create mode 100644 base/ocsp/shared/conf/tomcat.conf
 create mode 100644 base/tks/shared/conf/tomcat.conf

diff --git a/base/ca/shared/conf/CS.cfg.in b/base/ca/shared/conf/CS.cfg.in
index 980ed58..f625439 100644
--- a/base/ca/shared/conf/CS.cfg.in
+++ b/base/ca/shared/conf/CS.cfg.in
@@ -741,7 +741,7 @@ cmsgateway._003=## re-enroll for a new Admin Certificate:
 cmsgateway._004=##
 cmsgateway._005=##   (1) Become 'root'
 cmsgateway._006=##   (2) Type:  'service [PKI_INSTANCE_ID] stop'
-cmsgateway._007=##   (3) Edit '[PKI_INSTANCE_ROOT]/[PKI_INSTANCE_ID]/conf/CS.cfg'
+cmsgateway._007=##   (3) Edit '[PKI_CFG_PATH_NAME]'
 cmsgateway._008=##       and set the following name-value pairs (if necessary):
 cmsgateway._009=##
 cmsgateway._010=##           ca.Policy.enable=true
diff --git a/base/ca/shared/conf/tomcat.conf b/base/ca/shared/conf/tomcat.conf
new file mode 100644
index 0000000..92af5f8
--- /dev/null
+++ b/base/ca/shared/conf/tomcat.conf
@@ -0,0 +1,52 @@
+# System-wide configuration file for tomcat services
+# This will be sourced by tomcat and any secondary service
+# Values will be overridden by service-specific configuration
+# files in /etc/sysconfig
+#
+# Use this one to change default values for all services
+# Change the service specific ones to affect only one service
+# (see, for instance, /etc/sysconfig/tomcat)
+#
+
+# Where your java installation lives
+#JAVA_HOME="/usr/lib/jvm/jre"
+
+# Where your tomcat installation lives
+CATALINA_BASE="[PKI_INSTANCE_PATH]"
+#CATALINA_HOME="/usr/share/tomcat"
+#JASPER_HOME="/usr/share/tomcat"
+#CATALINA_TMPDIR="/var/cache/tomcat/temp"
+
+# You can pass some parameters to java here if you wish to
+#JAVA_OPTS="-Xminf0.1 -Xmaxf0.3"
+
+# Use JAVA_OPTS to set java.library.path for libtcnative.so
+#JAVA_OPTS="-Djava.library.path=/usr/lib"
+
+# What user should run tomcat
+TOMCAT_USER="[PKI_USER]"
+
+# You can change your tomcat locale here
+#LANG="en_US"
+
+# Run tomcat under the Java Security Manager
+SECURITY_MANAGER="[PKI_SECURITY_MANAGER]"
+
+# Time to wait in seconds, before killing process
+#SHUTDOWN_WAIT="30"
+
+# Whether to annoy the user with "attempting to shut down" messages or not
+#SHUTDOWN_VERBOSE="false"
+
+# Set the TOMCAT_PID location
+CATALINA_PID="[TOMCAT_PIDFILE]"
+
+# Set the tomcat log file
+TOMCAT_LOG="[TOMCAT_LOG_DIR]/tomcat-initd.log"
+
+# Connector port is 8080 for this tomcat instance
+#CONNECTOR_PORT="8080"
+
+# If you wish to further customize your tomcat environment,
+# put your own definitions here
+# (i.e. LD_LIBRARY_PATH for some jdbc drivers)
diff --git a/base/deploy/CMakeLists.txt b/base/deploy/CMakeLists.txt
index 397c9a3..f1bdafe 100644
--- a/base/deploy/CMakeLists.txt
+++ b/base/deploy/CMakeLists.txt
@@ -36,6 +36,7 @@ install(
 install(
     FILES
         config/pkideployment.cfg
+        config/pkislots.cfg
     DESTINATION
         ${DATA_INSTALL_DIR}/deployment/config
     PERMISSIONS
@@ -67,7 +68,7 @@ install(
         src/scriptlets/pkiparser.py
         src/scriptlets/pkiscriptlet.py
         src/scriptlets/security_databases.py
-        src/scriptlets/slot_assignment.py
+        src/scriptlets/slot_substitution.py
         src/scriptlets/subsystem_layout.py
         src/scriptlets/war_explosion.py
         src/scriptlets/webserver_layout.py
@@ -133,13 +134,13 @@ foreach(TOMCAT_SUBSYSTEM ${TOMCAT_SUBSYSTEMS})
     )
     install(CODE "execute_process(COMMAND
         ${CMAKE_COMMAND} -E create_symlink
-        \"${PYTHON_SITE_PACKAGES}/pki/deployment/security_databases.py\"
-        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/${TOMCAT_SUBSYSTEM}/050_security_databases\")"
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/slot_substitution.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/${TOMCAT_SUBSYSTEM}/050_slot_substitution\")"
     )
     install(CODE "execute_process(COMMAND
         ${CMAKE_COMMAND} -E create_symlink
-        \"${PYTHON_SITE_PACKAGES}/pki/deployment/slot_assignment.py\"
-        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/${TOMCAT_SUBSYSTEM}/060_slot_assignment\")"
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/security_databases.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/spawn/${TOMCAT_SUBSYSTEM}/060_security_databases\")"
     )
     install(CODE "execute_process(COMMAND
         ${CMAKE_COMMAND} -E create_symlink
@@ -171,23 +172,23 @@ foreach(TOMCAT_SUBSYSTEM ${TOMCAT_SUBSYSTEMS})
     )
 #   install(CODE "execute_process(COMMAND
 #       ${CMAKE_COMMAND} -E create_symlink
-#       \"${PYTHON_SITE_PACKAGES}/pki/deployment/slot_assignment.py\"
-#       \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/940_slot_assignment\")"
+#       \"${PYTHON_SITE_PACKAGES}/pki/deployment/slot_substitution.py\"
+#       \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/940_slot_substitution\")"
 #   )
     install(CODE "execute_process(COMMAND
         ${CMAKE_COMMAND} -E create_symlink
-        \"${PYTHON_SITE_PACKAGES}/pki/deployment/security_databases.py\"
-        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/950_security_databases\")"
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/war_explosion.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/950_war_explosion\")"
     )
     install(CODE "execute_process(COMMAND
         ${CMAKE_COMMAND} -E create_symlink
-        \"${PYTHON_SITE_PACKAGES}/pki/deployment/war_explosion.py\"
-        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/960_war_explosion\")"
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/subsystem_layout.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/960_subsystem_layout\")"
     )
     install(CODE "execute_process(COMMAND
         ${CMAKE_COMMAND} -E create_symlink
-        \"${PYTHON_SITE_PACKAGES}/pki/deployment/subsystem_layout.py\"
-        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/970_subsystem_layout\")"
+        \"${PYTHON_SITE_PACKAGES}/pki/deployment/security_databases.py\"
+        \"\$ENV{DESTDIR}${DATA_INSTALL_DIR}/deployment/destroy/${TOMCAT_SUBSYSTEM}/970_security_databases\")"
     )
     install(CODE "execute_process(COMMAND
         ${CMAKE_COMMAND} -E create_symlink
diff --git a/base/deploy/config/pkideployment.cfg b/base/deploy/config/pkideployment.cfg
index 954fa93..1122daa 100644
--- a/base/deploy/config/pkideployment.cfg
+++ b/base/deploy/config/pkideployment.cfg
@@ -1,9 +1,9 @@
 [Common]
 pki_source_root=/usr/share/pki
 pki_instance_root=/var/lib/pki
-pki_instance_configuration_root=/etc/pki
 pki_instance_log_root=/var/log/pki
-pki_instance_name=instance
+pki_instance_configuration_root=/etc/pki
+pki_instance_name=default
 pki_user=pkiuser
 pki_group=pkiuser
 pki_audit_group=pkiaudit
@@ -14,23 +14,30 @@ pki_https_port=443
 [Tomcat]
 pki_web_server=Tomcat
 pki_tomcat_root=/usr/share/tomcat
+pki_tomcat_systemd=/usr/sbin/tomcat-sysd
 pki_http_port=8080
 pki_https_port=8443
 pki_ajp_port=8009
+pki_proxy_https_port=443
+pki_proxy_http_port=80
 pki_security_manager=true
 [CA]
 pki_subsystem=CA
 pki_war_name=ca.war
+tomcat_server_port=9701
 [KRA]
 pki_subsystem=KRA
 pki_war_name=kra.war
+tomcat_server_port=10701
 [OCSP]
 pki_subsystem=OCSP
 pki_war_name=ocsp.war
+tomcat_server_port=11701
 [RA]
 pki_subsystem=RA
 [TKS]
 pki_subsystem=TKS
 pki_war_name=tks.war
+tomcat_server_port=13701
 [TPS]
 pki_subsystem=TPS
diff --git a/base/deploy/config/pkislots.cfg b/base/deploy/config/pkislots.cfg
new file mode 100644
index 0000000..b04b8ef
--- /dev/null
+++ b/base/deploy/config/pkislots.cfg
@@ -0,0 +1,88 @@
+[Apache]
+FORTITUDE_APACHE_SLOT=[FORTITUDE_APACHE]
+FORTITUDE_AUTH_MODULES_SLOT=[FORTITUDE_AUTH_MODULES]
+FORTITUDE_DIR_SLOT=[FORTITUDE_DIR]
+FORTITUDE_LIB_DIR_SLOT=[FORTITUDE_LIB_DIR]
+FORTITUDE_MODULE_SLOT=[FORTITUDE_MODULE]
+FORTITUDE_NSS_MODULES_SLOT=[FORTITUDE_NSS_MODULES]
+HTTPD_CONF_SLOT=[HTTPD_CONF]
+LIB_PREFIX_SLOT=[LIB_PREFIX]
+NON_CLIENTAUTH_SECURE_PORT_SLOT=[NON_CLIENTAUTH_SECURE_PORT]
+NSS_CONF_SLOT=[NSS_CONF]
+OBJ_EXT_SLOT=[OBJ_EXT]
+PKI_INSTANCE_ID_SLOT=[PKI_INSTANCE_ID]
+PKI_INSTANCE_INITSCRIPT_SLOT=[PKI_INSTANCE_INITSCRIPT]
+PKI_LOCKDIR_SLOT=[PKI_LOCKDIR]
+PKI_PIDDIR_SLOT=[PKI_PIDDIR]
+PKI_REGISTRY_FILE_SLOT=[PKI_REGISTRY_FILE]
+PORT_SLOT=[PORT]
+PROCESS_ID_SLOT=[PROCESS_ID]
+REQUIRE_CFG_PL_SLOT=[REQUIRE_CFG_PL]
+SECURE_PORT_SLOT=[SECURE_PORT]
+SECURITY_LIBRARIES_SLOT=[SECURITY_LIBRARIES]
+SERVER_NAME_SLOT=[SERVER_NAME]
+SERVER_ROOT_SLOT=[SERVER_ROOT]
+SYSTEM_LIBRARIES_SLOT=[SYSTEM_LIBRARIES]
+SYSTEM_USER_LIBRARIES_SLOT=[SYSTEM_USER_LIBRARIES]
+TMP_DIR_SLOT=[TMP_DIR]
+TPS_DIR_SLOT=[TPS_DIR]
+[Tomcat]
+INSTALL_TIME_SLOT=[INSTALL_TIME]
+PKI_ADMIN_SECURE_PORT_SLOT=[PKI_ADMIN_SECURE_PORT]
+PKI_ADMIN_SECURE_PORT_CONNECTOR_NAME_SLOT=[PKI_ADMIN_SECURE_PORT_CONNECTOR_NAME]
+PKI_ADMIN_SECURE_PORT_SERVER_COMMENT_SLOT=[PKI_ADMIN_SECURE_PORT_SERVER_COMMENT]
+PKI_AGENT_CLIENTAUTH_SLOT=[PKI_AGENT_CLIENTAUTH]
+PKI_AGENT_SECURE_PORT_SLOT=[PKI_AGENT_SECURE_PORT]
+PKI_AJP_PORT_SLOT=[PKI_AJP_PORT]
+PKI_AJP_REDIRECT_PORT_SLOT=[PKI_AJP_REDIRECT_PORT]
+PKI_CERT_DB_PASSWORD_SLOT=[PKI_CERT_DB_PASSWORD]
+PKI_CFG_PATH_NAME_SLOT=[PKI_CFG_PATH_NAME]
+PKI_CLOSE_AJP_PORT_COMMENT_SLOT=[PKI_CLOSE_AJP_PORT_COMMENT]
+PKI_CLOSE_ENABLE_PROXY_COMMENT_SLOT=[PKI_CLOSE_ENABLE_PROXY_COMMENT]
+PKI_CLOSE_SEPARATE_PORTS_SERVER_COMMENT_SLOT=[PKI_CLOSE_SEPARATE_PORTS_SERVER_COMMENT]
+PKI_CLOSE_SEPARATE_PORTS_WEB_COMMENT_SLOT=[PKI_CLOSE_SEPARATE_PORTS_WEB_COMMENT]
+PKI_EE_SECURE_CLIENT_AUTH_PORT_SLOT=[PKI_EE_SECURE_CLIENT_AUTH_PORT]
+PKI_EE_SECURE_CLIENT_AUTH_PORT_CONNECTOR_NAME_SLOT=[PKI_EE_SECURE_CLIENT_AUTH_PORT_CONNECTOR_NAME]
+PKI_EE_SECURE_CLIENT_AUTH_PORT_SERVER_COMMENT_SLOT=[PKI_EE_SECURE_CLIENT_AUTH_PORT_SERVER_COMMENT]
+PKI_EE_SECURE_CLIENT_AUTH_PORT_UI_SLOT=[PKI_EE_SECURE_CLIENT_AUTH_PORT_UI]
+PKI_EE_SECURE_PORT_SLOT=[PKI_EE_SECURE_PORT]
+PKI_EE_SECURE_PORT_CONNECTOR_NAME_SLOT=[PKI_EE_SECURE_PORT_CONNECTOR_NAME]
+PKI_EE_SECURE_PORT_SERVER_COMMENT_SLOT=[PKI_EE_SECURE_PORT_SERVER_COMMENT]
+PKI_FLAVOR_SLOT=[PKI_FLAVOR]
+PKI_GROUP_SLOT=[PKI_GROUP]
+PKI_INSTANCE_ID_SLOT=[PKI_INSTANCE_ID]
+PKI_INSTANCE_INITSCRIPT_SLOT=[PKI_INSTANCE_INITSCRIPT]
+PKI_INSTANCE_PATH_SLOT=[PKI_INSTANCE_PATH]
+PKI_INSTANCE_ROOT_SLOT=[PKI_INSTANCE_ROOT]
+PKI_LOCKDIR_SLOT=[PKI_LOCKDIR]
+PKI_MACHINE_NAME_SLOT=[PKI_MACHINE_NAME]
+PKI_OPEN_AJP_PORT_COMMENT_SLOT=[PKI_OPEN_AJP_PORT_COMMENT]
+PKI_OPEN_ENABLE_PROXY_COMMENT_SLOT=[PKI_OPEN_ENABLE_PROXY_COMMENT]
+PKI_OPEN_SEPARATE_PORTS_SERVER_COMMENT_SLOT=[PKI_OPEN_SEPARATE_PORTS_SERVER_COMMENT]
+PKI_OPEN_SEPARATE_PORTS_WEB_COMMENT_SLOT=[PKI_OPEN_SEPARATE_PORTS_WEB_COMMENT]
+PKI_PIDDIR_SLOT=[PKI_PIDDIR]
+PKI_PROXY_SECURE_PORT_SLOT=[PKI_PROXY_SECURE_PORT]
+PKI_PROXY_UNSECURE_PORT_SLOT=[PKI_PROXY_UNSECURE_PORT]
+PKI_RANDOM_NUMBER_SLOT=[PKI_RANDOM_NUMBER]
+PKI_REGISTRY_FILE_SLOT=[PKI_REGISTRY_FILE]
+PKI_SECURE_PORT_SLOT=[PKI_SECURE_PORT]
+PKI_SECURE_PORT_CONNECTOR_NAME_SLOT=[PKI_SECURE_PORT_CONNECTOR_NAME]
+PKI_SECURE_PORT_SERVER_COMMENT_SLOT=[PKI_SECURE_PORT_SERVER_COMMENT]
+PKI_SECURITY_MANAGER_SLOT=[PKI_SECURITY_MANAGER]
+PKI_SERVER_XML_CONF_SLOT=[PKI_SERVER_XML_CONF]
+PKI_SUBSYSTEM_TYPE_SLOT=[PKI_SUBSYSTEM_TYPE]
+PKI_SYSTEMD_SERVICENAME_SLOT=[PKI_SYSTEMD_SERVICENAME]
+PKI_UNSECURE_PORT_SLOT=[PKI_UNSECURE_PORT]
+PKI_UNSECURE_PORT_CONNECTOR_NAME_SLOT=[PKI_UNSECURE_PORT_CONNECTOR_NAME]
+PKI_UNSECURE_PORT_SERVER_COMMENT_SLOT=[PKI_UNSECURE_PORT_SERVER_COMMENT]
+PKI_USER_SLOT=[PKI_USER]
+PKI_WEBAPPS_NAME_SLOT=[PKI_WEBAPPS_NAME]
+TOMCAT_CFG_SLOT=[TOMCAT_CFG]
+TOMCAT_INSTANCE_COMMON_LIB_SLOT=[TOMCAT_INSTANCE_COMMON_LIB]
+TOMCAT_LOG_DIR_SLOT=[TOMCAT_LOG_DIR]
+TOMCAT_PIDFILE_SLOT=[TOMCAT_PIDFILE]
+TOMCAT_SERVER_PORT_SLOT=[TOMCAT_SERVER_PORT]
+TOMCAT_SSL2_CIPHERS_SLOT=[TOMCAT_SSL2_CIPHERS]
+TOMCAT_SSL3_CIPHERS_SLOT=[TOMCAT_SSL3_CIPHERS]
+TOMCAT_SSL_OPTIONS_SLOT=[TOMCAT_SSL_OPTIONS]
+TOMCAT_TLS_CIPHERS_SLOT=[TOMCAT_TLS_CIPHERS]
diff --git a/base/deploy/src/pkidestroy b/base/deploy/src/pkidestroy
index 6d0afd2..c54ba9a 100755
--- a/base/deploy/src/pkidestroy
+++ b/base/deploy/src/pkidestroy
@@ -30,6 +30,10 @@ try:
     import logging
     import os
     import pprint
+    import random
+    import socket
+    import string
+    import time
     from time import strftime as date
     from pki.deployment import pkiconfig as config
     from pki.deployment import pkiparser as parse
@@ -56,8 +60,27 @@ def main(argv):
     # Set the umask
     os.umask(config.PKI_DEPLOYMENT_DEFAULT_UMASK)
 
+    # Set installation time
+    ticks = time.time()
+    config.pki_install_time = time.asctime(time.localtime(ticks))
+
     # Generate a timestamp
-    config.pki_timestamp = date('%Y%m%d%H%M%S')
+    config.pki_timestamp = date('%Y%m%d%H%M%S', time.localtime(ticks))
+    config.pki_certificate_timestamp =\
+        date('%Y-%m-%d %H:%M:%S', time.localtime(ticks))
+
+    # Retrieve hostname
+    config.pki_hostname = socket.gethostname()
+
+    # Generate a random 'pin' for use as the security database password
+    pin_low  = 100000000000
+    pin_high = 999999999999
+    config.pki_pin = random.randint(pin_low, pin_high)
+
+    # Generate a one-time pin to be used prior to configuration
+    config.pki_one_time_pin =\
+        ''.join(random.choice(string.ascii_letters + string.digits)\
+        for x in range(20))
 
     # Initialize 'pretty print' for objects
     pp = pprint.PrettyPrinter(indent=4)
diff --git a/base/deploy/src/pkispawn b/base/deploy/src/pkispawn
index 2ac21a6..c537b8e 100755
--- a/base/deploy/src/pkispawn
+++ b/base/deploy/src/pkispawn
@@ -30,6 +30,10 @@ try:
     import logging
     import os
     import pprint
+    import random
+    import socket
+    import string
+    import time
     from time import strftime as date
     from pki.deployment import pkiconfig as config
     from pki.deployment import pkiparser as parse
@@ -56,8 +60,27 @@ def main(argv):
     # Set the umask
     os.umask(config.PKI_DEPLOYMENT_DEFAULT_UMASK)
 
+    # Set installation time
+    ticks = time.time()
+    config.pki_install_time = time.asctime(time.localtime(ticks))
+
     # Generate a timestamp
-    config.pki_timestamp = date('%Y%m%d%H%M%S')
+    config.pki_timestamp = date('%Y%m%d%H%M%S', time.localtime(ticks))
+    config.pki_certificate_timestamp =\
+        date('%Y-%m-%d %H:%M:%S', time.localtime(ticks))
+
+    # Retrieve hostname
+    config.pki_hostname = socket.gethostname()
+
+    # Generate a random 'pin' for use as the security database password
+    pin_low  = 100000000000
+    pin_high = 999999999999
+    config.pki_pin = random.randint(pin_low, pin_high)
+
+    # Generate a one-time pin to be used prior to configuration
+    config.pki_one_time_pin =\
+        ''.join(random.choice(string.ascii_letters + string.digits)\
+        for x in range(20))
 
     # Initialize 'pretty print' for objects
     pp = pprint.PrettyPrinter(indent=4)
@@ -151,6 +174,13 @@ def main(argv):
     config.pki_log.debug(pp.pformat(config.pki_subsystem_dict),
                          extra=config.PKI_INDENTATION_LEVEL_0)
 
+    # Read in the PKI slots configuration file.
+    parse.compose_pki_slots_dictionary()
+    config.pki_log.debug(log.PKI_DICTIONARY_SLOTS,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_slots_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+
     # Combine the various sectional dictionaries into a PKI master dictionary
     parse.compose_pki_master_dictionary()
     if not config.pki_update_flag:
diff --git a/base/deploy/src/scriptlets/finalization.py b/base/deploy/src/scriptlets/finalization.py
index 6007326..9a3c23c 100644
--- a/base/deploy/src/scriptlets/finalization.py
+++ b/base/deploy/src/scriptlets/finalization.py
@@ -44,6 +44,7 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
         filename = master['pki_root_prefix'] +\
                    config.PKI_DEPLOYMENT_REGISTRY_ROOT + "/" +\
                    master['pki_instance_name'] + "/" +\
+                   master['pki_web_server'].lower() + "/" +\
                    master['pki_subsystem'].lower() +"/" +\
                    "spawn" + "_" + "manifest" + "." +\
                    master['pki_timestamp'] + "." + "csv"
@@ -77,6 +78,7 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
         filename = master['pki_root_prefix'] +\
                    config.PKI_DEPLOYMENT_REGISTRY_ROOT + "/" +\
                    master['pki_instance_name'] + "/" +\
+                   master['pki_web_server'].lower() + "/" +\
                    master['pki_subsystem'].lower() +"/" +\
                    "respawn" + "_" + "manifest" + "." +\
                    master['pki_timestamp'] + "." + "csv"
diff --git a/base/deploy/src/scriptlets/initialization.py b/base/deploy/src/scriptlets/initialization.py
index 67c9325..408ddfb 100644
--- a/base/deploy/src/scriptlets/initialization.py
+++ b/base/deploy/src/scriptlets/initialization.py
@@ -38,6 +38,9 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                             extra=config.PKI_INDENTATION_LEVEL_0)
         config.pki_log.info(log.INITIALIZATION_SPAWN_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
+        # verify that this type of "subsystem" does NOT yet
+        # exist for this "instance"
+        util.instance.verify_subsystem_does_not_exist()
         # establish 'uid' and 'gid'
         util.identity.set_uid(master['pki_user'])
         util.identity.set_gid(master['pki_group'])
@@ -50,6 +53,9 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                             extra=config.PKI_INDENTATION_LEVEL_0)
         config.pki_log.info(log.INITIALIZATION_RESPAWN_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
+        # verify that this type of "subsystem" currently EXISTS
+        # for this "instance"
+        util.instance.verify_subsystem_exists()
         # establish 'uid' and 'gid'
         util.identity.set_uid(master['pki_user'])
         util.identity.set_gid(master['pki_group'])
@@ -62,6 +68,9 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                             extra=config.PKI_INDENTATION_LEVEL_0)
         config.pki_log.info(log.INITIALIZATION_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
+        # verify that this type of "subsystem" currently EXISTS
+        # for this "instance"
+        util.instance.verify_subsystem_exists()
         # establish 'uid' and 'gid'
         util.identity.set_uid(master['pki_user'])
         util.identity.set_gid(master['pki_group'])
diff --git a/base/deploy/src/scriptlets/instance_layout.py b/base/deploy/src/scriptlets/instance_layout.py
index 38234f4..baa261c 100644
--- a/base/deploy/src/scriptlets/instance_layout.py
+++ b/base/deploy/src/scriptlets/instance_layout.py
@@ -48,6 +48,11 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
         # establish instance registry
         util.directory.create(master['pki_registry_path'])
         util.directory.create(master['pki_instance_registry_path'])
+        # establish shared NSS security databases
+        util.directory.create(master['pki_database_path'])
+        # establish convenience symbolic links
+        util.symlink.create(master['pki_database_path'],
+                            master['pki_instance_database_link'])
         return self.rv
 
     def respawn(self):
@@ -67,31 +72,56 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
         # update instance registry
         util.directory.modify(master['pki_registry_path'])
         util.directory.modify(master['pki_instance_registry_path'])
+        # update shared NSS security databases
+        util.directory.modify(master['pki_database_path'])
+        # update convenience symbolic links
+        util.symlink.modify(master['pki_instance_database_link'])
         return self.rv
 
     def destroy(self):
         config.pki_log.info(log.INSTANCE_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
         # remove instance base
-        if util.directory.is_empty(master['pki_instance_path']):
-            util.directory.delete(master['pki_instance_path'])
-        if util.directory.is_empty(master['pki_path']):
-            util.directory.delete(master['pki_path'])
-        # remove instance logs
-        if util.directory.is_empty(master['pki_instance_log_path']):
-            util.directory.delete(master['pki_instance_log_path'])
-        if util.directory.is_empty(master['pki_log_path']):
-            util.directory.delete(master['pki_log_path'])
-        # remove instance configuration
-        if util.directory.is_empty(master['pki_instance_configuration_path']):
-            util.directory.delete(master['pki_instance_configuration_path'])
-        if util.directory.is_empty(master['pki_configuration_path']) and\
-           master['pki_configuration_path'] !=\
-           config.PKI_SHARED_CONFIGURATION_ROOT:
-            util.directory.delete(master['pki_configuration_path'])
-        # remove instance registry
-        if util.directory.is_empty(master['pki_instance_registry_path']):
-            util.directory.delete(master['pki_instance_registry_path'])
-        if util.directory.is_empty(master['pki_registry_path']):
-            util.directory.delete(master['pki_registry_path'])
+        if not config.pki_dry_run_flag:
+            if master['pki_subsystem'] in config.PKI_SUBSYSTEMS and\
+               util.instance.pki_subsystem_instances() == 0:
+                # remove instance base
+                util.directory.delete(master['pki_instance_path'])
+                util.directory.delete(master['pki_path'])
+                # remove instance logs
+                util.directory.delete(master['pki_instance_log_path'])
+                util.directory.delete(master['pki_log_path'])
+                # remove shared NSS security database path
+                util.directory.delete(master['pki_database_path'])
+                # remove instance configuration
+                util.directory.delete(master['pki_instance_configuration_path'])
+                if util.directory.is_empty(master['pki_configuration_path'])\
+                   and master['pki_configuration_path'] !=\
+                   config.PKI_SHARED_CONFIGURATION_ROOT:
+                    util.directory.delete(master['pki_configuration_path'])
+                # remove instance registry
+                util.directory.delete(master['pki_instance_registry_path'])
+                util.directory.delete(master['pki_registry_path'])
+                util.file.delete(master['pki_target_tomcat_conf'])
+
+        else:
+            # ALWAYS display correct information (even during dry_run)
+            if master['pki_subsystem'] in config.PKI_SUBSYSTEMS and\
+               util.instance.pki_subsystem_instances() == 1:
+                # remove instance base
+                util.directory.delete(master['pki_instance_path'])
+                util.directory.delete(master['pki_path'])
+                # remove instance logs
+                util.directory.delete(master['pki_instance_log_path'])
+                util.directory.delete(master['pki_log_path'])
+                # remove shared NSS security database path
+                util.directory.delete(master['pki_database_path'])
+                if util.directory.is_empty(master['pki_configuration_path'])\
+                   and master['pki_configuration_path'] !=\
+                   config.PKI_SHARED_CONFIGURATION_ROOT:
+                    util.directory.delete(master['pki_configuration_path'])
+                # remove instance registry
+                util.directory.delete(master['pki_instance_registry_path'])
+                util.directory.delete(master['pki_registry_path'])
+                util.file.delete(master['pki_target_tomcat_conf'])
         return self.rv
diff --git a/base/deploy/src/scriptlets/pkiconfig.py b/base/deploy/src/scriptlets/pkiconfig.py
index 505bfc0..31b0531 100644
--- a/base/deploy/src/scriptlets/pkiconfig.py
+++ b/base/deploy/src/scriptlets/pkiconfig.py
@@ -27,6 +27,7 @@ import logging
 PKI_DEPLOYMENT_DEFAULT_DIR_PERMISSIONS = 00770
 PKI_DEPLOYMENT_DEFAULT_EXE_PERMISSIONS = 00770
 PKI_DEPLOYMENT_DEFAULT_FILE_PERMISSIONS = 00660
+PKI_DEPLOYMENT_DEFAULT_SECURITY_DATABASE_PERMISSIONS = 00600
 PKI_DEPLOYMENT_DEFAULT_SGID_DIR_PERMISSIONS = 02770
 PKI_DEPLOYMENT_DEFAULT_SYMLINK_PERMISSIONS = 00777
 PKI_DEPLOYMENT_DEFAULT_UMASK = 00002
@@ -52,15 +53,21 @@ PKI_INDENTATION_LEVEL_4 = {'indent' : '............... '}
 #        in the configuration file (the value in the default configuration file
 #        should always match the 'default' instance name specified below).
 PKI_DEPLOYMENT_REGISTRY_ROOT = "/etc/sysconfig/pki"
-PKI_DEPLOYMENT_DEFAULT_INSTANCE_NAME = "instance"
+PKI_DEPLOYMENT_DEFAULT_INSTANCE_NAME = "default"
 PKI_DEPLOYMENT_DEFAULT_CONFIGURATION_FILE = "pkideployment.cfg"
+PKI_DEPLOYMENT_SLOTS_CONFIGURATION_FILE =\
+    "/usr/share/pki/deployment/config/pkislots.cfg"
 
 # NOTE: Top-level "/etc/pki" is owned by the "filesystem" package!
 PKI_SHARED_CONFIGURATION_ROOT = "/etc/pki"
 
 
 # PKI Deployment Global Variables
+pki_install_time = None
 pki_timestamp = None
+pki_hostname = None
+pki_pin = None
+pki_one_time_pin = None
 
 
 # PKI Deployment "Mandatory" Command-Line Variables
@@ -92,3 +99,4 @@ pki_common_dict = None
 pki_web_server_dict = None
 pki_subsystem_dict = None
 pki_master_dict = None
+pki_slots_dict = None
